package com.vendor.burn.model.config;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.burn.Messages;
import com.vendor.burn.log.Log;
import com.vendor.burn.model.TransferWay;
import com.vendor.burn.model.cmdline.CmdLineParam;
import com.vendor.burn.model.config.BurnConfig;
import com.vendor.burn.utilitily.FileUtils;
import com.vendor.burn.utilitily.PropertiesUtility;
import java.io.File;
import java.util.ArrayList;
import org.eclipse.osgi.util.NLS;

public class PreferenceConfig extends PropertiesUtility {
  public static final String PRE_OPEN_DEBUG = "open.debug";
  
  public static final String PRE_CHECK_SAMENETWORK = "check.network";
  
  public static final String PRE_TFTP_SPEED = "tftp.speed";
  
  public static final String PRE_TFTP_LOSING_PACKAGE_ENABLE = "tftp.losingpackage.enable";
  
  public static final String PRE_TFTP_LOSING_PACKAGE_COUNT = "tftp.losingpackage.count";
  
  public static final String PRE_TFTP_RETRY_COUNT = "tftp.retry.count";
  
  public static final String PRE_TFTP_NO_RESPONSE_TIMEOUT = "tftp.timeout.noresponse";
  
  public static final String PRE_TFTP_SPLIT_FILE_SIZE = "tftp.split.fileSize";
  
  public static final String PRE_TFTP_CRC_CHECK = "tftp.crc.check";
  
  public static final String PRE_TFTP_WINDOW_SIZE_OPEN = "tftp.windowSize.open";
  
  public static final String PRE_TFTP_WINDOW_SIZE_BLOCK_COUNT = "tftp.windowSize.blockCount";
  
  public static final String PRE_TFTP_BLOCK_SIZE = "tftp.blockSize";
  
  public static final String PRE_CMD_SPEED_EMMC_WRITE = "cmd.emmcWriteSpeed";
  
  public static final String PRE_CMD_EMMC_DISK_FORMAT_CONFIG = "cmd.emmcDiskFormat";
  
  public static final String PRE_CMD_EMMC_ERASE_BEFORE_BURN_CONFIG = "cmd.eraseBeforeBurn";
  
  public static final String PRE_CMD_NET_ETHACT_CONFIG = "cmd.ethact";
  
  public static final String PRE_CMD_I2C_BAUD_RATE = "cmd.i2c.baudrate";
  
  public static final String PRE_CMD_I2C_DEVICE_ADDRESS = "cmd.i2c.deviceAddress";
  
  public static final String PRE_CMD_I2C_DELAY = "cmd.i2c.delay";
  
  public static final String PRE_CMD_I2C_TIMEOUT = "cmd.i2c.timeout";
  
  public static final String PRE_CMD_I2C_RETRY_COUNT = "cmd.i2c.retry.count";
  
  public static final String PRE_IMG_FILL_CONFIG = "image.imageFill";
  
  public static final String PRE_IMG_FILL_NAND_PIN_SAVE_MODE = "image.openPinSaveMode";
  
  public static final String BURN_CONFIG_FILE = "burn.config";
  
  public static final String PREFERENCE_CONFIG_FILE = "preference.config";
  
  public static final boolean PRE_OPEN_DEBUG_INIT = false;
  
  public static final boolean PRE_CHECK_SAMENETWORK_INIT = true;
  
  public static final int PRE_TFTP_PORT_INIT = 69;
  
  public static final int PRE_TFTP_SPEED_INIT = 1024;
  
  public static final boolean PRE_TFTP_LOSING_PACKAGE_ENABLE_INIT = true;
  
  public static final int PRE_TFTP_LOSING_PACKAGE_COUNT_INIT = 15;
  
  public static final int PRE_TFTP_RETRY_COUNT_INIT = 5;
  
  public static final int PRE_TFTP_NO_RESPONSE_TIMEOUT_INIT = 10;
  
  public static final int PRE_TFTP_SPLIT_FILE_SIZE_INIT = 32;
  
  public static final boolean PRE_TFTP_CRC_CHECK_INIT = true;
  
  public static final boolean PRE_TFTP_WINDOW_SIZE_OPEN_INIT = true;
  
  public static final int PRE_TFTP_WINDOW_SIZE_BLOCK_COUNT_INIT = 3;
  
  public static final int PRE_CMD_SPEED_EMMC_WRITE_INIT = 3072;
  
  public static final boolean PRE_CMD_EMMC_DISK_FORMAT_CONFIG_INIT = false;
  
  public static final boolean PRE_CMD_EMMC_ERASE_BEFORE_BURN_CONFIG_INIT = false;
  
  public static final String PRE_CMD_NET_ETHACT_CONFIG_INIT = "Auto";
  
  public static final int PRE_CMD_I2C_BAUD_RATE_INIT = 409600;
  
  public static final int PRE_CMD_I2C_DEVICE_ADDRESS_INIT = 56;
  
  public static final int PRE_CMD_I2C_DELAY_INIT = 50;
  
  public static final int PRE_CMD_I2C_TIMEOUT_INIT = 60000;
  
  public static final int PRE_CMD_I2C_RETRY_COUNT_INIT = 30;
  
  public static final String PRE_IMG_FILL_CONFIG_INIT = "0x00";
  
  public static final boolean PRE_IMG_FILL_NAND_PIN_SAVE_MODE_INIT = true;
  
  private static final int PRE_TFTP_BLOCK_SIZE_INIT = 1468;
  
  private static boolean debugPrint = true;
  
  private static boolean checkNetWork = true;
  
  private static int tftpPort = 69;
  
  private static int tftpSpeed = 1024;
  
  private static boolean tftpLostEnable = true;
  
  private static int tftpLostCount = 15;
  
  private static int tftpRetryCount = 5;
  
  private static int tftpTimeoutNoresponse = 10;
  
  private static int tftpSplitFileSize = 32;
  
  private static boolean tftpCrcCheck = true;
  
  private static boolean tftpWinSizeOpen = true;
  
  private static int tftpWinSizeBlockCount = 3;
  
  private static int tftpBlockSize = 1468;
  
  private static int cmdEmmcWriteSpeed = 3072;
  
  private static boolean cmdEmmcDiskFormat = false;
  
  private static boolean cmdEraseBeforeBurn = false;
  
  private static String cmdEthact = "Auto";
  
  private static int cmdI2cBaudrate = 409600;
  
  private static int cmdI2cDeviceAddr = 56;
  
  private static int cmdI2cDelay = 50;
  
  private static int cmdI2cTimeout = 60000;
  
  private static int cmdI2cRetryCount = 30;
  
  private static String imgFillData = "0x00";
  
  private static boolean imgOpenPinSaveMode = true;
  
  private boolean loadResult = false;
  
  public PreferenceConfig(CmdLineParam cmdLineParam) {
    this.loadResult = loadPreferenceConfig(cmdLineParam);
  }
  
  protected boolean getParamBoolValue(String keyName) {
    return getParamBoolValue(keyName, "preference.config");
  }
  
  protected int getParamIntValue(String keyName) {
    return getParamIntValue(keyName, "preference.config");
  }
  
  protected String getParamStringValue(String keyName) {
    return getParamStringValue(keyName, "preference.config");
  }
  
  protected boolean loadPreferenceConfig(CmdLineParam cmdLineParam) {
    String path = FileUtils.toAbsolutePath("config" + File.separator + "preference.config");
    if (!FileUtils.isExists(path)) {
      Log.errorln(NLS.bind(Messages.MESSAGE_ERROR_FILE_PATH_DONT_EXIST, "preference.config"));
      return false;
    } 
    ArrayList<String> definitionLines = FileUtils.readAllLines(path);
    if (definitionLines == null) {
      Log.errorln(NLS.bind("Failed to read the file, the file path is as follows: ", path));
      return false;
    } 
    for (String s : definitionLines) {
      String line = s.trim().replace("\t", "");
      if (line.startsWith("["))
        continue; 
      if (line.contains("=")) {
        String[] ppt = line.split("=");
        if (ppt.length > 1)
          set(ppt[0], ppt[1]); 
      } 
    } 
    boolean debugOpen = getParamBoolValue("open.debug");
    if (this.convertSuccess) {
      setDebugPrint(debugOpen);
    } else {
      Log.errorln(NLS.bind(Messages.MESSAGE_ERROR_PARAMETER_DONT_FIND, "open.debug"));
      return false;
    } 
    TransferWay transferWay = BurnConfig.getTransferway();
    if (transferWay != null) {
      String transferWayName = transferWay.name().toLowerCase();
      if (transferWayName.contains("net") || transferWayName.contains("udp"))
        if (!loadTftpConfig())
          return true;  
    } 
    if (!loadCmdConfig())
      return true; 
    if (!loadImgConfig())
      return true; 
    Log.println(NLS.bind(Messages.MESSAGE_LOAD_FILE_SUCCESS, "preference.config"));
    return true;
  }
  
  private boolean loadImgConfig() {
    String imgFillData = getParamStringValue("image.imageFill");
    if (imgFillData != null) {
      setImgFillData(imgFillData);
    } else {
      Log.errorln(NLS.bind(Messages.MESSAGE_ERROR_PARAMETER_DONT_FIND, "image.imageFill"));
      return false;
    } 
    boolean imgOpenPinSaveMode = getParamBoolValue("image.openPinSaveMode");
    if (this.convertSuccess) {
      setImgOpenPinSaveMode(imgOpenPinSaveMode);
    } else {
      Log.errorln(NLS.bind(Messages.MESSAGE_ERROR_PARAMETER_DONT_FIND, "image.openPinSaveMode"));
      return false;
    } 
    return true;
  }
  
  private boolean loadCmdConfig() {
    int cmdEmmcWriteSpeed = getParamIntValue("cmd.emmcWriteSpeed");
    if (cmdEmmcWriteSpeed != -1) {
      setCmdEmmcWriteSpeed(cmdEmmcWriteSpeed);
    } else {
      Log.errorln(NLS.bind(Messages.MESSAGE_ERROR_PARAMETER_DONT_FIND, "cmd.emmcWriteSpeed"));
      return false;
    } 
    boolean cmdDiskFormat = getParamBoolValue("cmd.emmcDiskFormat");
    if (this.convertSuccess) {
      setCmdEmmcDiskFormat(cmdDiskFormat);
    } else {
      Log.errorln(NLS.bind(Messages.MESSAGE_ERROR_PARAMETER_DONT_FIND, "cmd.emmcDiskFormat"));
      return false;
    } 
    boolean cmdEraseBeforeBurn = getParamBoolValue("cmd.eraseBeforeBurn");
    if (this.convertSuccess) {
      setCmdEraseBeforeBurn(cmdEraseBeforeBurn);
    } else {
      Log.errorln(NLS.bind(Messages.MESSAGE_ERROR_PARAMETER_DONT_FIND, "cmd.eraseBeforeBurn"));
      return false;
    } 
    String cmdEthact = getParamStringValue("cmd.ethact");
    if (cmdEthact != null) {
      setCmdEthact(cmdEthact);
    } else {
      Log.errorln(NLS.bind(Messages.MESSAGE_ERROR_PARAMETER_DONT_FIND, "cmd.ethact"));
      return false;
    } 
    if (BurnConfig.getTransferway() == TransferWay.I2CBootrom) {
      int cmdI2cBaudrate = getParamIntValue("cmd.i2c.baudrate");
      if (cmdI2cBaudrate != -1) {
        setCmdI2cBaudrate(cmdI2cBaudrate);
      } else {
        Log.errorln(NLS.bind(Messages.MESSAGE_ERROR_PARAMETER_DONT_FIND, "cmd.i2c.baudrate"));
        return false;
      } 
      int cmdI2cDeviceAddr = getParamIntValue("cmd.i2c.deviceAddress");
      if (cmdI2cDeviceAddr != -1) {
        setCmdI2cDeviceAddr(cmdI2cDeviceAddr);
      } else {
        Log.errorln(NLS.bind(Messages.MESSAGE_ERROR_PARAMETER_DONT_FIND, "cmd.i2c.deviceAddress"));
        return false;
      } 
      int cmdI2cDelay = getParamIntValue("cmd.i2c.delay");
      if (cmdI2cDelay != -1) {
        setCmdI2cDelay(cmdI2cDelay);
      } else {
        Log.errorln(NLS.bind(Messages.MESSAGE_ERROR_PARAMETER_DONT_FIND, "cmd.i2c.delay"));
        return false;
      } 
      int cmdI2cTimeout = getParamIntValue("cmd.i2c.timeout");
      if (cmdI2cTimeout != -1) {
        setCmdI2cTimeout(cmdI2cTimeout);
      } else {
        Log.errorln(NLS.bind(Messages.MESSAGE_ERROR_PARAMETER_DONT_FIND, "cmd.i2c.timeout"));
        return false;
      } 
      int cmdI2cRetryCount = getParamIntValue("cmd.i2c.retry.count");
      if (cmdI2cRetryCount != -1) {
        setCmdI2cRetryCount(cmdI2cRetryCount);
      } else {
        Log.errorln(NLS.bind(Messages.MESSAGE_ERROR_PARAMETER_DONT_FIND, "cmd.i2c.retry.count"));
        return false;
      } 
    } 
    return true;
  }
  
  private boolean loadTftpConfig() {
    boolean checkNetWork = getParamBoolValue("check.network");
    if (this.convertSuccess) {
      setCheckNetWork(checkNetWork);
    } else {
      Log.errorln(NLS.bind(Messages.MESSAGE_ERROR_PARAMETER_DONT_FIND, "check.network"));
      return false;
    } 
    int tftpSpeed = getParamIntValue("tftp.speed");
    if (tftpSpeed != -1) {
      setTftpSpeed(tftpSpeed);
    } else {
      Log.errorln(NLS.bind(Messages.MESSAGE_ERROR_PARAMETER_DONT_FIND, "tftp.speed"));
      return false;
    } 
    boolean tftpLostEnable = getParamBoolValue("tftp.losingpackage.enable");
    if (this.convertSuccess) {
      setTftpLostEnable(tftpLostEnable);
    } else {
      Log.errorln(NLS.bind(Messages.MESSAGE_ERROR_PARAMETER_DONT_FIND, "tftp.losingpackage.enable"));
      return false;
    } 
    int tftpLostCount = getParamIntValue("tftp.losingpackage.count");
    if (tftpLostCount != -1) {
      setTftpLostCount(tftpLostCount);
    } else {
      Log.errorln(NLS.bind(Messages.MESSAGE_ERROR_PARAMETER_DONT_FIND, "tftp.losingpackage.count"));
      return false;
    } 
    int tftpRetryCount = getParamIntValue("tftp.retry.count");
    if (tftpRetryCount != -1) {
      setTftpRetryCount(tftpRetryCount);
    } else {
      Log.errorln(NLS.bind(Messages.MESSAGE_ERROR_PARAMETER_DONT_FIND, "tftp.retry.count"));
      return false;
    } 
    int tftpNoResponseTimeout = getParamIntValue("tftp.timeout.noresponse");
    if (tftpNoResponseTimeout != -1) {
      setTftpTimeoutNoresponse(tftpNoResponseTimeout);
    } else {
      Log.errorln(NLS.bind(Messages.MESSAGE_ERROR_PARAMETER_DONT_FIND, "tftp.timeout.noresponse"));
      return false;
    } 
    int tftpSplitFileSize = getParamIntValue("tftp.split.fileSize");
    if (tftpSplitFileSize != -1) {
      setTftpSplitFileSize(tftpSplitFileSize);
    } else {
      Log.errorln(NLS.bind(Messages.MESSAGE_ERROR_PARAMETER_DONT_FIND, "tftp.split.fileSize"));
      return false;
    } 
    boolean tftpCrcCheck = getParamBoolValue("tftp.crc.check");
    if (this.convertSuccess) {
      setTftpCrcCheck(tftpCrcCheck);
    } else {
      Log.errorln(NLS.bind(Messages.MESSAGE_ERROR_PARAMETER_DONT_FIND, "tftp.crc.check"));
      return false;
    } 
    if (!loadTftpConfiguration())
      return false; 
    return true;
  }
  
  private boolean loadTftpConfiguration() {
    if (this.convertSuccess) {
      setTftpWinSizeOpen(getParamBoolValue("tftp.windowSize.open"));
    } else {
      Log.errorln(NLS.bind(Messages.MESSAGE_ERROR_PARAMETER_DONT_FIND, "tftp.windowSize.open"));
      return false;
    } 
    int preTftpWinSizeBlockCount = getParamIntValue("tftp.windowSize.blockCount");
    if (preTftpWinSizeBlockCount != -1) {
      setTftpWinSizeBlockCount(preTftpWinSizeBlockCount);
    } else {
      Log.errorln(NLS.bind(Messages.MESSAGE_ERROR_PARAMETER_DONT_FIND, "tftp.windowSize.blockCount"));
      return false;
    } 
    int tftpBlockSizeInt = getParamIntValue("tftp.blockSize");
    if (tftpBlockSizeInt != -1) {
      setTftpBlockSize(tftpBlockSizeInt);
    } else {
      Log.errorln(NLS.bind(Messages.MESSAGE_ERROR_PARAMETER_DONT_FIND, "tftp.blockSize"));
      return false;
    } 
    return true;
  }
  
  public static int getTftpPort() {
    return tftpPort;
  }
  
  public static void setTftp(int tftpPort) {
    com.vendor.burn.model.config.PreferenceConfig.tftpPort = tftpPort;
  }
  
  public static int getTftpSpeed() {
    return tftpSpeed;
  }
  
  public static void setTftpSpeed(int tftpSpeed) {
    com.vendor.burn.model.config.PreferenceConfig.tftpSpeed = tftpSpeed;
  }
  
  public static boolean isTftpLostEnable() {
    return tftpLostEnable;
  }
  
  public static void setTftpLostEnable(boolean tftpLostEnable) {
    com.vendor.burn.model.config.PreferenceConfig.tftpLostEnable = tftpLostEnable;
  }
  
  public static int getTftpLostCount() {
    return tftpLostCount;
  }
  
  public static void setTftpLostCount(int tftpLostCount) {
    com.vendor.burn.model.config.PreferenceConfig.tftpLostCount = tftpLostCount;
  }
  
  public static int getTftpRetryCount() {
    return tftpRetryCount;
  }
  
  public static void setTftpRetryCount(int tftpRetryCount) {
    com.vendor.burn.model.config.PreferenceConfig.tftpRetryCount = tftpRetryCount;
  }
  
  public static int getTftpTimeoutNoresponse() {
    return tftpTimeoutNoresponse;
  }
  
  public static void setTftpTimeoutNoresponse(int tftpTimeoutNoresponse) {
    com.vendor.burn.model.config.PreferenceConfig.tftpTimeoutNoresponse = tftpTimeoutNoresponse;
  }
  
  public static int getTftpSplitFileSize() {
    return tftpSplitFileSize;
  }
  
  public static void setTftpSplitFileSize(int tftpSplitFileSize) {
    com.vendor.burn.model.config.PreferenceConfig.tftpSplitFileSize = tftpSplitFileSize;
  }
  
  public static boolean isTftpCrcCheck() {
    return tftpCrcCheck;
  }
  
  public static void setTftpCrcCheck(boolean tftpCrcCheck) {
    com.vendor.burn.model.config.PreferenceConfig.tftpCrcCheck = tftpCrcCheck;
  }
  
  public static boolean isTftpWinSizeOpen() {
    return tftpWinSizeOpen;
  }
  
  public static void setTftpWinSizeOpen(boolean tftpWinSizeOpen) {
    com.vendor.burn.model.config.PreferenceConfig.tftpWinSizeOpen = tftpWinSizeOpen;
  }
  
  public static int getTftpWinSizeBlockCount() {
    return tftpWinSizeBlockCount;
  }
  
  public static void setTftpWinSizeBlockCount(int tftpWinSizeBlockCount) {
    com.vendor.burn.model.config.PreferenceConfig.tftpWinSizeBlockCount = tftpWinSizeBlockCount;
  }
  
  public static int getTftpBlockSize() {
    return tftpBlockSize;
  }
  
  public static void setTftpBlockSize(int tftpBlockSize) {
    com.vendor.burn.model.config.PreferenceConfig.tftpBlockSize = tftpBlockSize;
  }
  
  public static int getCmdEmmcWriteSpeed() {
    return cmdEmmcWriteSpeed;
  }
  
  public static void setCmdEmmcWriteSpeed(int cmdEmmcWriteSpeed) {
    com.vendor.burn.model.config.PreferenceConfig.cmdEmmcWriteSpeed = cmdEmmcWriteSpeed;
  }
  
  public static boolean isCmdEraseBeforeBurn() {
    return cmdEraseBeforeBurn;
  }
  
  public static void setCmdEraseBeforeBurn(boolean cmdEraseBeforeBurn) {
    com.vendor.burn.model.config.PreferenceConfig.cmdEraseBeforeBurn = cmdEraseBeforeBurn;
  }
  
  public static String getCmdEthact() {
    return cmdEthact;
  }
  
  public static void setCmdEthact(String cmdEthact) {
    com.vendor.burn.model.config.PreferenceConfig.cmdEthact = cmdEthact;
  }
  
  public static int getCmdI2cBaudrate() {
    return cmdI2cBaudrate;
  }
  
  public static void setCmdI2cBaudrate(int cmdI2cBaudrate) {
    com.vendor.burn.model.config.PreferenceConfig.cmdI2cBaudrate = cmdI2cBaudrate;
  }
  
  public static int getCmdI2cDeviceAddr() {
    return cmdI2cDeviceAddr;
  }
  
  public static void setCmdI2cDeviceAddr(int cmdI2cDeviceAddr) {
    com.vendor.burn.model.config.PreferenceConfig.cmdI2cDeviceAddr = cmdI2cDeviceAddr;
  }
  
  public static int getCmdI2cDelay() {
    return cmdI2cDelay;
  }
  
  public static void setCmdI2cDelay(int cmdI2cDelay) {
    com.vendor.burn.model.config.PreferenceConfig.cmdI2cDelay = cmdI2cDelay;
  }
  
  public static int getCmdI2cTimeout() {
    return cmdI2cTimeout;
  }
  
  public static void setCmdI2cTimeout(int cmdI2cTimeout) {
    com.vendor.burn.model.config.PreferenceConfig.cmdI2cTimeout = cmdI2cTimeout;
  }
  
  public static int getCmdI2cRetryCount() {
    return cmdI2cRetryCount;
  }
  
  public static void setCmdI2cRetryCount(int cmdI2cRetryCount) {
    com.vendor.burn.model.config.PreferenceConfig.cmdI2cRetryCount = cmdI2cRetryCount;
  }
  
  public static String getImgFillData() {
    return imgFillData;
  }
  
  public static void setImgFillData(String imgFillData) {
    com.vendor.burn.model.config.PreferenceConfig.imgFillData = imgFillData;
  }
  
  public static boolean isImgOpenPinSaveMode() {
    return imgOpenPinSaveMode;
  }
  
  public static void setImgOpenPinSaveMode(boolean imgOpenPinSaveMode) {
    com.vendor.burn.model.config.PreferenceConfig.imgOpenPinSaveMode = imgOpenPinSaveMode;
  }
  
  public static boolean isCheckNetWork() {
    return checkNetWork;
  }
  
  public static void setCheckNetWork(boolean checkNetWork) {
    com.vendor.burn.model.config.PreferenceConfig.checkNetWork = checkNetWork;
  }
  
  public static boolean isDebugPrint() {
    return debugPrint;
  }
  
  public static void setDebugPrint(boolean debugPrint) {
    com.vendor.burn.model.config.PreferenceConfig.debugPrint = debugPrint;
  }
  
  public static boolean isCmdEmmcDiskFormat() {
    return cmdEmmcDiskFormat;
  }
  
  public static void setCmdEmmcDiskFormat(boolean cmdEmmcDiskFormat) {
    com.vendor.burn.model.config.PreferenceConfig.cmdEmmcDiskFormat = cmdEmmcDiskFormat;
  }
  
  public boolean isLoadResult() {
    return this.loadResult;
  }
  
  public void setLoadResult(boolean loadResult) {
    this.loadResult = loadResult;
  }
}
